package com.aza.vp.he;

public class Initial_Prob
{
	
	public Initial_Prob()
	{
		long num_of_royal_flush = num_of_royal_flush();		
		long num_of_straight_flushes = num_of_straight_flushes() - num_of_royal_flush();
		long num_of_four_of_a_kind = num_of_four_of_a_kind();
		long num_of_three_of_a_kind = num_of_three_of_a_kind();
		long num_of_full_house = num_of_full_house();
		long num_of_flush = num_of_flush() - num_of_straight_flushes();
		long num_of_straights = num_of_straights() - num_of_straight_flushes();		
		long num_of_two_pairs = num_of_two_pairs();
		long num_of_one_pair = num_of_one_pair();
		long num_of_high_card = num_of_high_card() - num_of_straight_flushes - num_of_straights - num_of_flush - num_of_royal_flush;
		
		System.out.println("num_of_royal_flush: " + num_of_royal_flush);
		System.out.println("num_of_four_of_a_kind: " + num_of_four_of_a_kind);
		System.out.println("num_of_three_of_a_kind: " + num_of_three_of_a_kind);
		System.out.println("num_of_full_house: " + num_of_full_house);
		System.out.println("num_of_flush: " + num_of_flush);
		System.out.println("num_of_straights: " + num_of_straights);
		System.out.println("num_of_straight_flushes: " + num_of_straight_flushes);
		System.out.println("num_of_two_pairs: " + num_of_two_pairs);
		System.out.println("num_of_one_pair: " + num_of_one_pair);
		System.out.println("num_of_high_card: " + num_of_high_card);
		
		long total = num_of_royal_flush
						+ num_of_four_of_a_kind
						+ num_of_three_of_a_kind
						+ num_of_full_house
						+ num_of_flush
						+ num_of_straights
						+ num_of_straight_flushes
						+ num_of_two_pairs
						+ num_of_one_pair
						+ num_of_high_card;
		
		System.out.println("total: " + total);
		System.out.println("total: " + Prob.combinations_k(52, 5));
	}
	

	
	public long num_of_royal_flush()
	{
		long c = Prob.combinations_k(4, 1);		
		return c;	
	}
	
	public long num_of_four_of_a_kind()
	{
		long c = Prob.combinations_k(13, 1) 
				* Prob.combinations_k(4, 4)
				* Prob.combinations_k(12, 1)
				* Prob.combinations_k(4, 1);		
		return c;	
	}
	
	public long num_of_three_of_a_kind()
	{
		long c = Prob.combinations_k(13, 1) 
				* Prob.combinations_k(4, 3)
				* Prob.combinations_k(12, 2)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1);		
		return c;	
	}
	
	public long num_of_full_house()
	{
		long c = Prob.combinations_k(13, 2) 
				* Prob.combinations_k(2, 1)
				* Prob.combinations_k(4, 3)
				* Prob.combinations_k(4, 2);
		return c;	
	}
	
	public long num_of_flush()
	{
		long c = Prob.combinations_k(4, 1) 
				* Prob.combinations_k(13, 5);
		
		return c;	
	}
	
	public long num_of_straight_flushes()
	{
		long c = Prob.combinations_k(10, 1) 
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(1, 1)
				* Prob.combinations_k(1, 1)
				* Prob.combinations_k(1, 1)
				* Prob.combinations_k(1, 1);
		
		return c;	
	}
	
	
	public long num_of_straights()
	{
		long c = Prob.combinations_k(10, 1) 
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1);
		
		return c;
	}
	
	
	public long num_of_two_pairs()
	{
		long c = Prob.combinations_k(13, 2) 
				* Prob.combinations_k(4, 2)
				* Prob.combinations_k(4, 2)
				* Prob.combinations_k(44, 1);
		return c;	
	}
	
	public long num_of_one_pair()
	{
		long c = Prob.combinations_k(13, 1) 
				* Prob.combinations_k(4, 2)
				* Prob.combinations_k(12, 3)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1);
		return c;	
	}
	
	public long num_of_high_card()
	{
		long c = Prob.combinations_k(13, 5) 
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1)
				* Prob.combinations_k(4, 1);
		return c;
	}
}
