package com.aza.vp.game;

public class TensOrBetter extends JacksOrBetter
{
	// 6/5 min Ten
	
	
	public TensOrBetter(int type) {
		super(type);
	}


	int payout[] =
        {
                800,
                50,
                25,
                6,
                5,
                4,
                3,
                2,
                1
        };
	
	String hand_cat[] =
        {
                "ROYAL_FLUSH",
                "STRAIGHT_FLUSH",
                "FOUR_OF_KIND",
                "FULL_HOUSE",
                "FLUSH",
                "STRAIGHT",
                "THREE_OF_KIND",
                "TWO_PAIRS",
                "TENS_OR_BETTER"
        };
	
	
	@Override
	public int checkHand(int[] hand, int n_wild)
	{
		return checkHand_static(hand, n_wild, 8);
	}
	
	 @Override
	 public int[] getPayoutTable()
	 {
		 return payout;
	 }


	   	@Override
	   	public String[] getHandCat()
	   	{
	   		return hand_cat;
	   	}


	   	@Override
	   	public int getPayout(int hand)
	   	{
	   		return payout[hand];
	   	}


	   	@Override
	   	public String getHandString(int res)
	   	{
	   		return hand_cat[res];
	   	}
}
